﻿using IRaCIS.Core.Domain.Share;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Application.Helper
{
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = true, Inherited = false)]
    public class DictionaryTranslateAttribute : Attribute
    {

        public string DicParentCode { get; set; }

        public DicDataTypeEnum DataTypeEnum { get; set; }

        public CriterionType? CriterionType { get; set; }

        public DictionaryTranslateAttribute(string dicParentCode)
        {
            DicParentCode = dicParentCode;

        }

        public DictionaryTranslateAttribute(string dicParentCode, CriterionType criterionType )
        {
            DicParentCode = dicParentCode;

            CriterionType = criterionType;
        }
    }
}
